#include "Cgiu_sm.h"
#include "Cgiu.h"

using namespace statemap;
// Static class declarations.
Map1_WaitForCmd    Map1::WaitForCmd("Map1::WaitForCmd", 0);
Map1_DecisionState    Map1::DecisionState("Map1::DecisionState", 1);
Map1_Error    Map1::Error("Map1::Error", 2);

void CgiuState::CheckForErrors(CgiuContext& context)
{
    Default(context);
    return;
}

void CgiuState::GetData(CgiuContext& context)
{
    Default(context);
    return;
}

void CgiuState::GetLamp(CgiuContext& context)
{
    Default(context);
    return;
}

void CgiuState::SendForces(CgiuContext& context)
{
    Default(context);
    return;
}

void CgiuState::SwitchLamp(CgiuContext& context)
{
    Default(context);
    return;
}

void CgiuState::Default(CgiuContext& context)
{
    throw (
        TransitionUndefinedException(
            context.getState().getName(),
            context.getTransition()));

    return;
}

void Map1_Default::GetData(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();
    bool loopbackFlag = false;

    CgiuState& EndStateName = context.getState();

    context.clearState();
    try
    {
        ctxt.UnacceptableAlert();
        context.setState(EndStateName);
    }
    catch (...)
    {
        context.setState(EndStateName);
        throw;
    }

    return;
}

void Map1_Default::GetLamp(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();
    bool loopbackFlag = false;

    CgiuState& EndStateName = context.getState();

    context.clearState();
    try
    {
        ctxt.UnacceptableAlert();
        context.setState(EndStateName);
    }
    catch (...)
    {
        context.setState(EndStateName);
        throw;
    }

    return;
}

void Map1_Default::SwitchLamp(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();
    bool loopbackFlag = false;

    CgiuState& EndStateName = context.getState();

    context.clearState();
    try
    {
        ctxt.UnacceptableAlert();
        context.setState(EndStateName);
    }
    catch (...)
    {
        context.setState(EndStateName);
        throw;
    }

    return;
}

void Map1_Default::CheckForErrors(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();
    bool loopbackFlag = false;

    CgiuState& EndStateName = context.getState();

    context.clearState();
    try
    {
        ctxt.UnacceptableAlert();
        context.setState(EndStateName);
    }
    catch (...)
    {
        context.setState(EndStateName);
        throw;
    }

    return;
}

void Map1_Default::SendForces(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();
    bool loopbackFlag = false;

    CgiuState& EndStateName = context.getState();

    context.clearState();
    try
    {
        ctxt.UnacceptableAlert();
        context.setState(EndStateName);
    }
    catch (...)
    {
        context.setState(EndStateName);
        throw;
    }

    return;
}

void Map1_WaitForCmd::GetData(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    (context.getState()).Exit(context);
    context.clearState();
    try
    {
        ctxt.GetSensorData();
        context.setState(Map1::DecisionState);
    }
    catch (...)
    {
        context.setState(Map1::DecisionState);
        throw;
    }
    (context.getState()).Entry(context);

    return;
}

void Map1_WaitForCmd::GetLamp(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    (context.getState()).Exit(context);
    context.clearState();
    try
    {
        ctxt.GetLampStatus();
        context.setState(Map1::DecisionState);
    }
    catch (...)
    {
        context.setState(Map1::DecisionState);
        throw;
    }
    (context.getState()).Entry(context);

    return;
}

void Map1_WaitForCmd::SendForces(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    CgiuState& EndStateName = context.getState();

    context.clearState();
    try
    {
        ctxt.SendFingerForces();
        context.setState(EndStateName);
    }
    catch (...)
    {
        context.setState(EndStateName);
        throw;
    }

    return;
}

void Map1_WaitForCmd::SwitchLamp(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    (context.getState()).Exit(context);
    context.clearState();
    try
    {
        ctxt.SwitchLampStatus();
        context.setState(Map1::DecisionState);
    }
    catch (...)
    {
        context.setState(Map1::DecisionState);
        throw;
    }
    (context.getState()).Entry(context);

    return;
}

void Map1_DecisionState::CheckForErrors(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    if (ctxt.m_isTimeout == 1)
    {
        (context.getState()).Exit(context);
        context.clearState();
        try
        {
            ctxt.TimeoutAlert();
            context.setState(Map1::Error);
        }
        catch (...)
        {
            context.setState(Map1::Error);
            throw;
        }
        (context.getState()).Entry(context);
    }
    else if (ctxt.m_wrongAnswer == 1)
    {
        (context.getState()).Exit(context);
        context.clearState();
        try
        {
            ctxt.WrongAnswerAlert();
            context.setState(Map1::Error);
        }
        catch (...)
        {
            context.setState(Map1::Error);
            throw;
        }
        (context.getState()).Entry(context);
    }
    else
    {
        (context.getState()).Exit(context);
        context.setState(Map1::WaitForCmd);
        (context.getState()).Entry(context);
    }

    return;
}

void Map1_Error::GetData(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    (context.getState()).Exit(context);
    context.clearState();
    try
    {
        ctxt.Reset();
        ctxt.GetSensorData();
        context.setState(Map1::DecisionState);
    }
    catch (...)
    {
        context.setState(Map1::DecisionState);
        throw;
    }
    (context.getState()).Entry(context);

    return;
}

void Map1_Error::GetLamp(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    (context.getState()).Exit(context);
    context.clearState();
    try
    {
        ctxt.Reset();
        ctxt.GetLampStatus();
        context.setState(Map1::DecisionState);
    }
    catch (...)
    {
        context.setState(Map1::DecisionState);
        throw;
    }
    (context.getState()).Entry(context);

    return;
}

void Map1_Error::SwitchLamp(CgiuContext& context)
{
    Cgiu& ctxt = context.getOwner();

    (context.getState()).Exit(context);
    context.clearState();
    try
    {
        ctxt.Reset();
        ctxt.SwitchLampStatus();
        context.setState(Map1::DecisionState);
    }
    catch (...)
    {
        context.setState(Map1::DecisionState);
        throw;
    }
    (context.getState()).Entry(context);

    return;
}
