#if __GNUG__ >= 2
#  pragma implementation
#endif

//#include "ScanFile.h"
#include "cyberGraspRaw2RoboJoint.h"
#include <stdio.h>

//---- newclass ---------------------------------------------------------

CyberGraspRaw2RoboJoint::CyberGraspRaw2RoboJoint()// : baseclass()
{
   strcpy(_Label, "final.cal" );
   
   initFromFile();
}

CyberGraspRaw2RoboJoint::~CyberGraspRaw2RoboJoint()
{
}

int CyberGraspRaw2RoboJoint::initFromFile(void)
{
   char space[25];   
   char * filename =space;
   /* space for filename, maximum of 24+.dat */
#ifdef VxWorks 
   strcpy (filename,"/CFG/\0");   
   /* must copy for multiple calls */
#else
   strcpy (filename,"\0");
#endif
   strncat (filename,_Label,24);
   if ((_file_ptr=fopen(filename,"r"))==NULL)
   {
	printf ( "%s: Couldn't open <%s>\n",_Label, filename);
	return ( -1 );    
   }   
   else
   {
      readFromCalibFile(_file_ptr);      
      fclose (_file_ptr);
      return 0;      
   }
}


int CyberGraspRaw2RoboJoint::setHumanCalibrationData(float *x)
{
   float *new_float_ptr, *old_float_ptr;

   old_float_ptr = &byte2angle[0][0];
   new_float_ptr = x;
   
   for (int i = 0; i < sizeof(byte2angle)/sizeof(float); i++, new_float_ptr++, old_float_ptr++)
         *old_float_ptr = *new_float_ptr;
      
   return (0);
}

int CyberGraspRaw2RoboJoint::setRobotCalibrationData(float *x)
{
   float *new_float_ptr, *old_float_ptr;

   old_float_ptr = &angle2robo[0][0];
   new_float_ptr = x;

   for (int i = 0; i < sizeof(angle2robo)/sizeof(float); i++, new_float_ptr++, old_float_ptr++)
         *old_float_ptr = *new_float_ptr;
      
   return (0);
}

int CyberGraspRaw2RoboJoint::getRoboJoints(float rawData[24], float roboJoints [16])
{
   int i, j;
   
   float *raw, *trafo_byte2angle, *trafo_angle2robo, *tmp_erg, *roboJoints_ptr;
   float tmp_matrix[16] = {0.0};
   
   // assingning float-pointers
   roboJoints_ptr   = roboJoints;
   tmp_erg          = &tmp_matrix[0];
   raw              = rawData;
   
   trafo_byte2angle = &byte2angle[0][0];
   trafo_angle2robo = &angle2robo[0][0];
   
   for ( i = 0; i < 16; i++,  raw++, tmp_erg++)
   {

      if ( (i == 7) || (i == 11) || (i == 15) )
         trafo_byte2angle += 2;
      else
      {
         // subtracting raw-data from offset
         *tmp_erg = *(trafo_byte2angle++)  -  *raw;
         
         // multiplicating gain
         *tmp_erg = *tmp_erg  *  *(trafo_byte2angle++);
         
         //         cout << "cyberGrasp tmp_joints: " << i << " " << tmp_matrix[i] << endl;
      }
   }
//    raw = &raw[11];
//    trafo_byte2angle = &byte2angle[0][0];
//    tmp_erg          = &tmp_matrix[7];

//    *tmp_erg = *(trafo_byte2angle+15) *  ( *(trafo_byte2angle+23) - 1.0 ) * ( *(trafo_byte2angle+22) - *raw )
//             - 0.25 * *(trafo_byte2angle+31) * ( *(trafo_byte2angle+30) - *(raw+4) );
//    tmp_erg += 4;

//    *tmp_erg = *(trafo_byte2angle+1) *  *(trafo_byte2angle+9) * ( *(trafo_byte2angle+8) - *raw )
//             - 0.25 * *(trafo_byte2angle+17) * ( *(trafo_byte2angle+16) - *(raw+4) );
//    tmp_erg += 4;

//    *tmp_erg = *(trafo_byte2angle+1) *  *(trafo_byte2angle+9) * ( *(trafo_byte2angle+8) - *raw )
//             + 0.75 * *(trafo_byte2angle+17) * ( *(trafo_byte2angle+16) - *(raw+4) );
//    tmp_erg += 4;

   tmp_matrix[7] = byte2angle[1][7] * (byte2angle[2][7] - 1.0) * (byte2angle[2][6] - rawData[11])
                 - 0.25 * byte2angle[3][7] * ( byte2angle[3][6] - rawData[15]);
   tmp_matrix[11] = byte2angle[1][7] * byte2angle[2][7] * (byte2angle[2][6] - rawData[11])
                 - 0.25 * byte2angle[3][7] * ( byte2angle[3][6] - rawData[15]);
   tmp_matrix[15] = byte2angle[1][7] * byte2angle[2][7] * (byte2angle[2][6] - rawData[11])
                 + 0.75 * byte2angle[3][7] * ( byte2angle[3][6] - rawData[15]);
   
//    cout << "cyberGrasp tmp_joints: " << 7 << " " << tmp_matrix[7] << endl;   
//    cout << "cyberGrasp tmp_joints: " << 11 << " " << tmp_matrix[11] << endl;
//    cout << "cyberGrasp tmp_joints: " << 15 << " " << tmp_matrix[15] << endl;
   
   tmp_erg          = &tmp_matrix[0];

   // transformation angle -> robo-angle
   for ( i = 0; i < sizeof(tmp_matrix)/sizeof(float); i++)
   {
      // calculating one row
      *roboJoints_ptr= *tmp_erg     * ( *trafo_angle2robo   ) +
                       *(tmp_erg+1) * (*(trafo_angle2robo+1)) +
                       *(tmp_erg+2) * (*(trafo_angle2robo+2)) +
                       *(tmp_erg+3) * (*(trafo_angle2robo+3)) +
                       *(trafo_angle2robo+4);

      // calculating next matrix-block
      roboJoints_ptr++;
      trafo_angle2robo += 5;
      if (!((i+1)%4))
         tmp_erg += 4;
            
      //      cout << endl << "roboJoint-ptr: " << i << " " << roboJoints[i] << " ";
   }

   
   //   cout << endl;
   
   return (0);
}

void CyberGraspRaw2RoboJoint::readFromCalibFile(FILE* file_ptr)
{
   char *str, line[100];
   int dummy, tmp;
   
   // searching the beginning of the handcalibration-data
   rewind ( file_ptr );
   do {
      str = fgets ( line, sizeof(line)-1, file_ptr );
   } while ( str != NULL && strstr(line, "FINGER 0")==NULL);
   if ( str == NULL ) {
      printf ( "Calibration-file not valid! Can't find \"FINGER 0\"\n");
   }

   // reading offset and gain from calib-file
   for (int i = 0; i < 6; i++)
   {
      for (int j = 0; j < 8; j+=2)
      {
         fscanf( file_ptr, "%d %d %f %d\n", &dummy, &tmp,  &(byte2angle[i][j+1]), &dummy);
         byte2angle[i][j]= (float)(tmp);
      }
      str = fgets ( line, sizeof(line)-1, file_ptr );
   }

   // reading the transformationmatrices
   readMatrix ( file_ptr, "RTHUMB:\n",  5, 4, angle2robo[0]);
   readMatrix ( file_ptr, "RINDEX:\n",  5, 4, angle2robo[1]);
   readMatrix ( file_ptr, "RMIDDLE:\n", 5, 4, angle2robo[2]);
   readMatrix ( file_ptr, "RRING:\n",   5, 4, angle2robo[3]);
}

int CyberGraspRaw2RoboJoint::readMatrix ( FILE *file, char *matName, int rows, int cols, 
                                          float *matrix )
{
  char buf[100];
  char *str;
  int i, j;

  rewind ( file );
  
  do {
    str = fgets ( buf, sizeof(buf)-1, file );
  } while ( str != NULL && strstr(buf, matName)==NULL);

  if ( str == NULL ) {
    printf ( "Frame <%s> not found\n", matName );
    return ( -1 );
  }
  for ( i = 0; i < rows; i++ ) {
     for ( j = 0; j < cols; j++ ) {
        if ( fscanf ( file, "%f", matrix++ ) != 1 ){
           printf ( "Error scanning frame <%s>, line %d\n", matName, i );
           return ( -1 );
        }
     }
     fscanf ( file, "\n" );
  }

  return ( 0 );
}
