//-*-Mode: C++;-*-
#ifndef CYBERGRASPRAW2ROBOJOINT
#define CYBERGRASPRAW2ROBOJOINT

#include <string.h>
#include <stdio.h>
#include <iostream.h>

/* #include "finger.h" */
  
class CyberGraspRaw2RoboJoint
{
   // holds transformation-data for four fingers, thumb and palm
   // [finger][offset,gain]
   float byte2angle [6][8];
   // holds for each finger a transformationmatrix (5x4)
   float angle2robo [4][20];

   // file-handling
   FILE *_file_ptr;
   char _Label[24];
   void readFromCalibFile(FILE *);
   int readMatrix ( FILE *file, char *matName, int rows, int cols, float *matrix );
  
public:
   CyberGraspRaw2RoboJoint();
   ~CyberGraspRaw2RoboJoint();

   /* functions called once e.g. in constructor,*/
   /* but may be called later for recalibration  */
   /* reads from personal calibration File */
   int initFromFile();

   /* sets calibration variables, mainly offset and gain of sensor values */
   int setHumanCalibrationData(float *);
   int setRobotCalibrationData(float *);

   // length of rawData:    24
   // length of roboJoints: 16
   int getRoboJoints (float rawData[24], float roboJoints[16]);
   /* getRoboTipPos (float rawData[23], float tipPos [12]) */
   /* getHumanTipPos (float rawData[23], float tipPos [12]) */
   
};

#endif
